#ifndef FUNCIONES_h
#define FUNCIONES_h

#include <bitswap.h>
#include <chipsets.h>
#include <color.h>
#include <colorpalettes.h>
#include <colorutils.h>
#include <controller.h>
#include <cpp_compat.h>
#include <dmx.h>
#include <FastLED.h>
#include <fastled_config.h>
#include <fastled_delay.h>
#include <fastled_progmem.h>
#include <fastpin.h>
#include <fastspi.h>
#include <fastspi_bitbang.h>
#include <fastspi_dma.h>
#include <fastspi_nop.h>
#include <fastspi_ref.h>
#include <fastspi_types.h>
#include <hsv2rgb.h>
#include <led_sysdefs.h>
#include <lib8tion.h>
#include <noise.h>
#include <pixelset.h>
#include <pixeltypes.h>
#include <platforms.h>
#include <power_mgt.h>

#include "configuracion.h"

void inicializaTiraLed(CRGB []);
void retardo (uint16_t);
void cambiarBrillo(uint8_t);


void ping(CRGB [],CRGB::HTMLColorCode, CRGB::HTMLColorCode, uint8_t);
void pong(CRGB [],CRGB::HTMLColorCode, CRGB::HTMLColorCode, uint8_t);
void rellenar(CRGB [],CRGB::HTMLColorCode, uint8_t);
void rellenarInversa(CRGB [],CRGB::HTMLColorCode, uint8_t);
void estela(CRGB [],CRGB::HTMLColorCode, uint8_t, uint8_t);
void estelaInversa(CRGB [],CRGB::HTMLColorCode, uint8_t, uint8_t);
void rellenarDeUnoEnUno(CRGB [],CRGB::HTMLColorCode, CRGB::HTMLColorCode, uint8_t);
void rellenarDeUnoEnUnoInversa(CRGB [],CRGB::HTMLColorCode, CRGB::HTMLColorCode, uint8_t);

void arcoirisFijo(CRGB [],uint8_t, uint8_t);
void arcoirisDesplazamiento(CRGB [], uint8_t, uint8_t);

void fade(CRGB [], CRGB , uint8_t );

void test(CRGB []);


#endif
