#include "funciones.h"


CRGB tira_Leds[NUM_LEDS_MAX]; // array con tantos chips como lleva la tira. Mantiene el color de los LED en cada momento.
CRGB::HTMLColorCode color; // color principal del juego de luces - Va cambiando según el juego
CRGB::HTMLColorCode colorFondo; // color secundario del juego de luces - Va cambiando según el juego

uint8_t brillo=255;  //valores entre 0-255. Es el brillo de la tira led que por defecto está al máximo
uint8_t velocidad;  //valores entre 0-255. Se va ajustando en función del efecto y del juego. A menor valor más rápido
uint8_t velocidadDegradado;  //valores entre 0-255. Sirve para funciones con degradado. A menor valor más larga es la estela de color que deja
uint8_t inicioEspectro;  //valores entre 0-255. Sirve para funciones de Arcoiris. El 0 significa que el arcoiris empieza en rojo y avanza hasta violeta. A mayor valor se desplaza el inicio del espectro
uint8_t repeticionEspectro; //valores entre 0-255.  Sirve para funciones de Arcoiris. Determina a partir de cuándo se repiten los colores. A valor más pequeño menos repeticiones de color. A mayor valor el arcoiris se repite varias veces

void setup() {
  retardo(2000);//retardo inicial por seguridad
  inicializaTiraLed(tira_Leds);
  cambiarBrillo(brillo);
}
 
void loop() {
    
    //Test para averiguar qué tipo de tira LED tenemos (RGB, GBR, BRG)
    //Pone toda la tira en rojo(R), después en verde(G) y por último en azul (B)
    test(tira_Leds);


    //Efecto fade o transición suave entre colores
    //Modifica suavemente el color de la tira hasta alcanzar el color que indiquemos. A menor valor de velocidad mas rápido cambiará de color.
    velocidad=10;
    color=CRGB::Red;
    fade(tira_Leds, color, velocidad );
    color=CRGB::Yellow;
    fade(tira_Leds, color, velocidad );
    color=CRGB::Green;
    fade(tira_Leds, color, velocidad );
    color=CRGB::Blue;
    fade(tira_Leds, color, velocidad );
    color=CRGB::Black;
    fade(tira_Leds, color, velocidad );


    //Efecto ida (ping) y vuelta (pong) de un solo led a lo largo de toda la tira
    //Se consiguen efectos singulares modificando tanto el color como el color de fondo
    velocidad=40;
    color=CRGB::White;
    colorFondo=CRGB::Black;    
    ping(tira_Leds,colorFondo, color, velocidad);
    pong(tira_Leds,colorFondo, color, velocidad);


    //Rellena led a led, y en la dirección indicada en la tira, del color que indiquemos
    color=CRGB::Red;
    rellenar(tira_Leds,color, velocidad);
    //Rellena led a led, y en la dirección contraria a la indicada en la tira, del color que indiquemos
    color=CRGB::Green;
    rellenarInversa(tira_Leds,color, velocidad);
 

    //Efecto similar a ping(estela) pong(estelaInversa) pero dejando una estela que se desvanece
    velocidad=50;
    velocidadDegradado=50; //a menor valor más larga es la estela que deja
    color=CRGB::Blue;
    estela(tira_Leds, color, velocidad, velocidadDegradado);
    color=CRGB::Yellow;
    estelaInversa(tira_Leds, color, velocidad, velocidadDegradado);

    
    
    //Efecto donde un led recorriendo la tira de un extremo al otro permaneciendo encendido cuando llega al destino
    //Después los siguientes led hacen lo mismo pero llegando hasta la posición anterior que su predecesor
    velocidad=3;
    color=CRGB::Purple;
    colorFondo=CRGB::White;    
    rellenarDeUnoEnUno(tira_Leds,colorFondo, color, velocidad);
    rellenarDeUnoEnUnoInversa(tira_Leds,colorFondo, color, velocidad);


    
    //Efecto arcoiris
    inicioEspectro=0; //el 0 significa que el arcoiris empieza en rojo y avanza hasta violeta. A mayor valor se desplaza el inicio del espectro
    repeticionEspectro=10; //determina a partir de cuándo se repiten los colores. A valor más pequeño menos repeticiones de color. A mayor valor el arcoiris se repite varias veces
    //El arcoiris permanece estático
    arcoirisFijo(tira_Leds,inicioEspectro, repeticionEspectro);
    //Hacemos una pausa de 3 segundos
    retardo(3000);
    //El arcoiris se desplaza según la velocidad indicada
    velocidad=5;
    arcoirisDesplazamiento(tira_Leds, repeticionEspectro, velocidad);
    
}
